#include <stdio.h>
extern unsigned short fast_crc16(unsigned short sum, 
                                 unsigned char const *p, 
                                 unsigned long len);

extern unsigned long fast_crc32(unsigned long sum, 
                                 unsigned char *p, 
                                 unsigned long len);
 
extern const unsigned short __checksum;
extern const unsigned int crc_start;
extern const unsigned int crc_end;
 
void main(void)
{
     unsigned short sum=0;
 
     sum=fast_crc16(sum, (unsigned char const *)&crc_start, 
                   (const unsigned long)&crc_end - (const unsigned long)&crc_start);
 
     if(sum!=__checksum)
          printf("***Checksum failed: %hx instead of %hx!***\n",sum, __checksum);
     else
          printf("***Checksum is correct!***\n");
}
